global gDownloadObject, gActivityClicked, gNetOpGroupNum, gPlaybackType, gMoaType

on prepareFrame
end

on exitFrame me
  if voidp(gDownloadObject) then
    gDownloadObject = new(script("Download Manager Object"))
  end if
  opPriority = 1
  if gPlaybackType <> #moa then
    optype = #pre
  else
    case gMoaType of
      #bbshock, #shock:
        optype = #pre
      #client:
        optype = #download
    end case
  end if
  sourceFileList = me.getActivityList()
  if the runMode = "Author" then
    Extension = ".dcr"
    cstextension = ".cct"
  else
    Extension = ".dcr"
    cstextension = ".cct"
  end if
  add(sourceFileList, [#opPriority: 1, #filePath: "@ActivityEnd" & Extension, #fileSize: 72 * 1024, #optype: #pre])
  add(sourceFileList, [#opPriority: 1, #filePath: "@mov/GNRC" & Extension, #fileSize: 924 * 1024, #optype: #pre])
  fileSize = gActivityClicked.promoMovieSize
  if fileSize <> 0 then
    add(sourceFileList, [#opPriority: 1, #filePath: "@mov/" & gActivityClicked.Icon & Extension, #fileSize: fileSize * 1024, #optype: #pre])
  end if
  gNetOpGroupNum = gDownloadObject.initNetOp(sourceFileList)
end

on getActivityList me
  activityCode = gActivityClicked.Icon
  contentFolderName = activityCode.char[1..2] & "/"
  activityFolderName = activityCode & "/"
  sourceRootPath = "@///" & contentFolderName & activityFolderName
  activityList = []
  totalRecords = gActivityClicked.cast.count
  repeat with f = 1 to totalRecords
    activityRecord = [:]
    currentFile = gActivityClicked.cast[f]
    if gActivityClicked.downloadSize.count < f then
      fileSize = 0
    else
      fileSize = getAt(gActivityClicked.downloadSize, f)
    end if
    addProp(activityRecord, #opPriority, 1)
    addProp(activityRecord, #filePath, sourceRootPath & currentFile)
    addProp(activityRecord, #fileSize, fileSize * 1024)
    addProp(activityRecord, #optype, #pre)
    add(activityList, activityRecord)
  end repeat
  return activityList
end
