property pOffMember, pOffOverMember, pOnMember, pDisabledMember, pMouseDownSound, pMouseUpSound, pMouseOverSound, pMouseDownChannel, pMouseUpChannel, pMouseOverChannel, pDisabled, pClickedCommand, pMySprite, pMyMouseDown, pTmpMember

on PushButton_Enable me, bEnable
  if voidp(bEnable) then
    pDisabled = not pDisabled
  else
    pDisabled = not bEnable
  end if
  pMySprite = sprite(me.spriteNum)
  if pDisabled then
    SwapMember(pDisabledMember)
    pMyMouseDown = 0
  else
    SwapMember(pOffMember)
  end if
  sendSprite(me.spriteNum, #Cursor_EnableChange, not pDisabled)
end

on PushButton_IsEnabled me
  return not pDisabled
end

on beginSprite me
  pMySprite = sprite(me.spriteNum)
  pTmpMember = VOID
  if pDisabled then
    sendSprite(me.spriteNum, #Cursor_EnableChange, not pDisabled)
    SwapMember(pDisabledMember)
  else
    SwapMember(pOffMember)
  end if
  pMyMouseDown = 0
end

on mouseDown me
  if not pDisabled then
    pMyMouseDown = 1
    ShowPushed(me, 1)
    updateStage()
  end if
end

on mouseUp me
  if not pDisabled and pMyMouseDown then
    pMyMouseDown = 0
    ShowPushed(me, 0)
    if pClickedCommand <> EMPTY then
      updateStage()
      do(pClickedCommand)
    end if
  end if
end

on mouseUpOutSide me
  if pMyMouseDown then
    pMyMouseDown = 0
    SetMouseOverMe(me, 0)
  end if
end

on mouseEnter me
  if pMyMouseDown then
    ShowPushed(me, 1)
  else
    if not (the mouseDown) then
      SetMouseOverMe(me, 1)
    end if
  end if
end

on mouseLeave me
  SetMouseOverMe(me, 0)
end

on exitFrame me
  if not voidp(pTmpMember) then
    SwapMember(pTmpMember)
    pTmpMember = VOID
  end if
end

on SwapMember mbrNew
  if pMySprite.member <> mbrNew then
    pMySprite.member = mbrNew
    pTmpMember = VOID
  end if
end

on ShowPushed me, bPushed
  if not pDisabled then
    if bPushed then
      pTmpMember = pOnMember
      if not voidp(pMouseDownSound) and (pMouseDownSound <> #none) then
        puppetSound(pMouseDownChannel, pMouseDownSound)
      end if
    else
      pTmpMember = pOffOverMember
      if not voidp(pMouseUpSound) and (pMouseUpSound <> #none) then
        puppetSound(pMouseUpChannel, pMouseUpSound)
      end if
    end if
  end if
end

on SetMouseOverMe me, bOverMe
  if not pDisabled then
    if bOverMe then
      pTmpMember = pOffOverMember
      if not voidp(pMouseOverSound) and (pMouseOverSound <> #none) then
        puppetSound(pMouseOverChannel, pMouseOverSound)
      end if
    else
      pTmpMember = pOffMember
    end if
  end if
end

on changeMembers me, iUp, iRoll, iDown, iDis
  set the member of sprite the spriteNum of me to iUp
  pOffMember = iUp
  pOffOverMember = iRoll
  pOnMember = iDown
  pDisabledMember = iDis
  if pOffOverMember = VOID then
    the itemDelimiter = "_"
    base = item 1 of pOffMember
    if member(string(base & "_RO")).memberNum <> -1 then
      pOffOverMember = base & "_RO"
    else
      pOffOverMember = iUp
    end if
    if member(string(base & "_DWN")).memberNum <> -1 then
      pOnMember = base & "_DWN"
    else
      pOnMember = iUp
    end if
    if member(string(base & "_DIS")).memberNum <> -1 then
      pDisabledMember = base & "_DIS"
    else
      pDisabledMember = iUp
    end if
  end if
end

on getPropertyDescriptionList me
  lPropDesc = [:]
  theMember = sprite(the currentSpriteNum).member
  theMemberNum = theMember.number
  lPropDesc.addProp(#pOffMember, [#comment: "Button Up member", #format: #member, #default: theMember])
  lPropDesc.addProp(#pOffOverMember, [#comment: "Rollover member", #format: #member, #default: member(theMemberNum + 1)])
  lPropDesc.addProp(#pOnMember, [#comment: "Button Down member", #format: #member, #default: member(theMemberNum + 2)])
  lPropDesc.addProp(#pDisabledMember, [#comment: "Disabled member", #format: #member, #default: theMember])
  lPropDesc.addProp(#pDisabled, [#comment: "Initially disabled:", #format: #boolean, #default: 0])
  lPropDesc.addProp(#pClickedCommand, [#comment: "Command to send when clicked:", #format: #string, #default: "sendSprite(the spriteNum of me, #PushButton_Clicked)"])
  lSoundsAvailable = GetSuitableMembers([#sound])
  if lSoundsAvailable.count() then
    lSoundsAvailable.addAt(1, #none)
    lPropDesc.addProp(#pMouseOverSound, [#comment: "Sound when mouse rolls over:", #format: #sound, #range: lSoundsAvailable, #default: #none])
    lPropDesc.addProp(#pMouseOverChannel, [#comment: "Sound channel for over:", #format: #integer, #range: [#min: 1, #max: 8], #default: 3])
    lPropDesc.addProp(#pMouseUpSound, [#comment: "Sound for mouse up:", #format: #sound, #range: lSoundsAvailable, #default: #none])
    lPropDesc.addProp(#pMouseUpChannel, [#comment: "Sound channel for up:", #format: #integer, #range: [#min: 1, #max: 8], #default: 4])
    lPropDesc.addProp(#pMouseDownSound, [#comment: "Sound for mouse down:", #format: #sound, #range: lSoundsAvailable, #default: #none])
    lPropDesc.addProp(#pMouseDownChannel, [#comment: "Sound channel for down:", #format: #integer, #range: [#min: 1, #max: 8], #default: 5])
  end if
  return lPropDesc
end

on isOKToAttach me, ySpriteType, nSpriteNum
  bIsOK = 0
  if ySpriteType = #graphic then
    bIsOK = 1
  end if
  return bIsOK
end

on getBehaviorDescription me
  return getDescriptionText(me)
end
